blob: 76f6171768e4358cf0500193793d04a559b0d195 [file] [log] [blame]
Linus Torvalds1da177e2005-04-16 15:20:36 -07001# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
Steven Rostedt03fa25d2009-04-29 22:52:22 -04005PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
Steven Rostedt281c9da2009-04-29 22:52:23 -04006 localmodconfig localyesconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -07007
Al Viro61bee202008-08-25 04:51:27 -04008ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
Arnaud Lacombe838a2e52010-09-04 17:10:20 -040011Kconfig := Kconfig
Al Viro61bee202008-08-25 04:51:27 -040012endif
Sam Ravnborge703f752007-10-25 20:42:18 +020013
Yann E. MORINc2838e62012-11-22 01:06:04 +010014# We need this, in case the user has it in its environment
15unexport CONFIG_
16
Linus Torvalds1da177e2005-04-16 15:20:36 -070017xconfig: $(obj)/qconf
Sam Ravnborge703f752007-10-25 20:42:18 +020018 $< $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070019
20gconfig: $(obj)/gconf
Sam Ravnborge703f752007-10-25 20:42:18 +020021 $< $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070022
23menuconfig: $(obj)/mconf
Sam Ravnborge703f752007-10-25 20:42:18 +020024 $< $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070025
26config: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020027 $< --oldaskconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070028
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020029nconfig: $(obj)/nconf
30 $< $(Kconfig)
31
Linus Torvalds1da177e2005-04-16 15:20:36 -070032oldconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020033 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070034
35silentoldconfig: $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090036 $(Q)mkdir -p include/config include/generated
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020037 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070038
Arnaud Lacombe50bce3e2011-07-01 18:13:03 -040039localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090040 $(Q)mkdir -p include/config include/generated
Arnaud Lacombe22d550a2011-07-20 00:40:09 -040041 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
Michal Marek7a996d32010-08-04 14:05:07 +020042 $(Q)if [ -f .config ]; then \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020043 cmp -s .tmp.config .config || \
44 (mv -f .config .config.old.1; \
45 mv -f .tmp.config .config; \
46 $(obj)/conf --silentoldconfig $(Kconfig); \
47 mv -f .config.old.1 .config.old) \
48 else \
49 mv -f .tmp.config .config; \
50 $(obj)/conf --silentoldconfig $(Kconfig); \
Steven Rostedta7c02602009-05-07 11:09:55 -040051 fi
Steven Rostedt03fa25d2009-04-29 22:52:22 -040052 $(Q)rm -f .tmp.config
53
EGRY Gabor10200262008-01-11 23:40:00 +010054# Create new linux.pot file
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020055# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
EGRY Gabor46d26312008-01-11 23:46:11 +010056update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
Peter Foleye2aef4d2011-12-18 18:15:16 -050057 $(Q)echo " GEN config.pot"
Peter Foleya24a1b82011-04-26 18:13:05 -040058 $(Q)xgettext --default-domain=linux \
59 --add-comments --keyword=_ --keyword=N_ \
60 --from-code=UTF-8 \
61 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
62 --directory=$(srctree) --directory=$(objtree) \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020063 --output $(obj)/config.pot
64 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
Paul Bollefa0ad6572011-11-05 12:21:30 +010065 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
66 $(srctree)/arch/*/um/Kconfig`; \
EGRY Gabor10200262008-01-11 23:40:00 +010067 do \
Peter Foleye2aef4d2011-12-18 18:15:16 -050068 echo " GEN $$i"; \
Sam Ravnborg42175162008-04-25 21:15:41 +020069 $(obj)/kxgettext $$i \
EGRY Gabor10200262008-01-11 23:40:00 +010070 >> $(obj)/config.pot; \
71 done )
Peter Foleye2aef4d2011-12-18 18:15:16 -050072 $(Q)echo " GEN linux.pot"
EGRY Gabor10200262008-01-11 23:40:00 +010073 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020074 --output $(obj)/linux.pot
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020075 $(Q)rm -f $(obj)/config.pot
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -070076
Sam Ravnborg0748cb32010-07-31 23:35:31 +020077PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -070078
Sam Ravnborg0748cb32010-07-31 23:35:31 +020079allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020080 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070081
Adam Leefb16d892012-09-01 01:05:17 +080082PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -070083
Adam Leefb16d892012-09-01 01:05:17 +080084listnewconfig olddefconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020085 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070086
Adam Leefb16d892012-09-01 01:05:17 +080087# oldnoconfig is an alias of olddefconfig, because people already are dependent
88# on its behavior(sets new symbols to their default value but not 'n') with the
89# counter-intuitive name.
90oldnoconfig: $(obj)/conf
91 $< --olddefconfig $(Kconfig)
92
Sam Ravnborg7cf3d732010-07-31 23:35:34 +020093savedefconfig: $(obj)/conf
94 $< --$@=defconfig $(Kconfig)
95
Linus Torvalds1da177e2005-04-16 15:20:36 -070096defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020098 $< --defconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070099else
Sam Ravnborg2266cfd2007-10-25 20:31:19 +0200100 @echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
Sam Ravnborg4062f1a2010-07-31 23:35:26 +0200101 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700102endif
103
104%_defconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +0200105 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700106
107# Help text used by make help
108help:
109 @echo ' config - Update current config utilising a line-oriented program'
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200110 @echo ' nconfig - Update current config utilising a ncurses menu based program'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700111 @echo ' menuconfig - Update current config utilising a menu based program'
112 @echo ' xconfig - Update current config utilising a QT based front-end'
113 @echo ' gconfig - Update current config utilising a GTK based front-end'
114 @echo ' oldconfig - Update current config utilising a provided .config as base'
Steven Rostedt03fa25d2009-04-29 22:52:22 -0400115 @echo ' localmodconfig - Update current config disabling modules not loaded'
Steven Rostedt281c9da2009-04-29 22:52:23 -0400116 @echo ' localyesconfig - Update current config converting local mods to core'
Markus Heidelberg590a5852009-05-18 01:36:46 +0200117 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200118 @echo ' defconfig - New config with default from ARCH supplied defconfig'
Sam Ravnborg7cf3d732010-07-31 23:35:34 +0200119 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
Jesper Juhle11f0492006-02-25 21:52:50 +0100120 @echo ' allnoconfig - New config where all options are answered with no'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200121 @echo ' allyesconfig - New config where all options are accepted with yes'
122 @echo ' allmodconfig - New config selecting modules when possible'
123 @echo ' alldefconfig - New config with all symbols set to default'
124 @echo ' randconfig - New config with random answer to all options'
Sam Ravnborg861b4ea2010-07-31 23:35:28 +0200125 @echo ' listnewconfig - List new options'
Adam Leefb16d892012-09-01 01:05:17 +0800126 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700127
Sam Ravnborg2982de62006-07-27 22:10:27 +0200128# lxdialog stuff
129check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
130
Rob Landleye9e40e12007-10-15 19:23:12 -0500131# Use recursively expanded variables so we do not call gcc unless
Sam Ravnborg2982de62006-07-27 22:10:27 +0200132# we really need to do so. (Do not call gcc as part of make mrproper)
Arnaud Lacombe9ba95682010-08-22 20:03:06 -0400133HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
134 -DLOCALE
Sam Ravnborg2982de62006-07-27 22:10:27 +0200135
Linus Torvalds1da177e2005-04-16 15:20:36 -0700136# ===========================================================================
137# Shared Makefile for the various kconfig executables:
138# conf: Used for defconfig, oldconfig and related targets
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200139# nconf: Used for the nconfig target.
140# Utilizes ncurses
Markus Heidelberg6f26e5e2009-05-18 01:36:45 +0200141# mconf: Used for the menuconfig target
Linus Torvalds1da177e2005-04-16 15:20:36 -0700142# Utilizes the lxdialog package
143# qconf: Used for the xconfig target
144# Based on QT which needs to be installed to compile it
145# gconf: Used for the gconfig target
146# Based on GTK which needs to be installed to compile it
147# object files used by all kconfig flavours
148
Sam Ravnborg2982de62006-07-27 22:10:27 +0200149lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
150lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
151
Linus Torvalds1da177e2005-04-16 15:20:36 -0700152conf-objs := conf.o zconf.tab.o
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200153mconf-objs := mconf.o zconf.tab.o $(lxdialog)
154nconf-objs := nconf.o zconf.tab.o nconf.gui.o
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -0700155kxgettext-objs := kxgettext.o zconf.tab.o
Peter Foleyf1943042011-04-26 18:00:05 -0400156qconf-cxxobjs := qconf.o
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400157qconf-objs := zconf.tab.o
158gconf-objs := gconf.o zconf.tab.o
Linus Torvalds1da177e2005-04-16 15:20:36 -0700159
Masahiro Yamada022af622014-08-19 16:34:22 +0900160hostprogs-y := conf nconf mconf kxgettext qconf gconf
Linus Torvalds1da177e2005-04-16 15:20:36 -0700161
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400162clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400163clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200164clean-files += mconf qconf gconf nconf
EGRY Gabor10200262008-01-11 23:40:00 +0100165clean-files += config.pot linux.pot
Linus Torvalds1da177e2005-04-16 15:20:36 -0700166
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100167# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
168PHONY += $(obj)/dochecklxdialog
169$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
170$(obj)/dochecklxdialog:
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400171 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100172
173always := dochecklxdialog
174
Sam Ravnborgaa1e5ef2007-08-12 23:15:44 +0200175# Add environment specific flags
176HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
Yuri Vasilevski70a6a0c2005-10-30 15:03:20 -0800177
Linus Torvalds1da177e2005-04-16 15:20:36 -0700178# generated files seem to need this to find local include files
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400179HOSTCFLAGS_zconf.lex.o := -I$(src)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700180HOSTCFLAGS_zconf.tab.o := -I$(src)
181
Arnaud Lacombe378dbb22011-05-23 02:08:52 -0400182LEX_PREFIX_zconf := zconf
183YACC_PREFIX_zconf := zconf
184
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400185HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
186HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700187
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400188HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
Adrian Bunk37193142006-01-02 11:25:30 +0100189HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
Arnaud Lacombe1ea3ad42011-06-05 23:36:05 -0400190 -Wno-missing-prototypes
Linus Torvalds1da177e2005-04-16 15:20:36 -0700191
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400192HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
193
Justin Lecher544e7e52013-03-06 14:02:02 +0100194HOSTLOADLIBES_nconf = $(shell \
195 pkg-config --libs menu panel ncurses 2>/dev/null \
196 || echo "-lmenu -lpanel -lncurses" )
Linus Torvalds1da177e2005-04-16 15:20:36 -0700197$(obj)/qconf.o: $(obj)/.tmp_qtcheck
198
Masahiro Yamada022af622014-08-19 16:34:22 +0900199ifeq ($(MAKECMDGOALS),xconfig)
Roman Zippelb3a52252005-11-21 21:32:38 -0800200$(obj)/.tmp_qtcheck: $(src)/Makefile
Linus Torvalds1da177e2005-04-16 15:20:36 -0700201-include $(obj)/.tmp_qtcheck
202
203# QT needs some extra effort...
204$(obj)/.tmp_qtcheck:
Roman Zippelb3a52252005-11-21 21:32:38 -0800205 @set -e; echo " CHECK qt"; dir=""; pkg=""; \
Alexander Stein133c5f72010-08-31 17:34:37 +0200206 if ! pkg-config --exists QtCore 2> /dev/null; then \
207 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
208 pkg-config --exists qt 2> /dev/null && pkg=qt; \
209 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
210 if [ -n "$$pkg" ]; then \
211 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
212 libs="\$$(shell pkg-config $$pkg --libs)"; \
213 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
214 dir="$$(pkg-config $$pkg --variable=prefix)"; \
215 else \
216 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
217 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
218 done; \
219 if [ -z "$$dir" ]; then \
Michal Marek5b580fa2012-07-07 23:32:18 +0200220 echo >&2 "*"; \
221 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
222 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
223 echo >&2 "* either qmake can be found or install pkg-config or set"; \
224 echo >&2 "* the QTDIR environment variable to the correct location."; \
225 echo >&2 "*"; \
Alexander Stein133c5f72010-08-31 17:34:37 +0200226 false; \
227 fi; \
228 libpath=$$dir/lib; lib=qt; osdir=""; \
229 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
230 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
231 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
232 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
233 cflags="-I$$dir/include"; \
234 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
235 moc="$$dir/bin/moc"; \
236 fi; \
237 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
238 echo "*"; \
239 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
240 echo "*"; \
241 moc="/usr/bin/moc"; \
242 fi; \
Sam Ravnborgab919c02005-11-06 11:05:21 +0100243 else \
Michal Marek458452f2010-09-13 13:41:31 +0200244 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
245 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
Yaakov Selkowitz48485942012-07-04 15:23:29 -0500246 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
247 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
Roman Zippelb3a52252005-11-21 21:32:38 -0800248 fi; \
249 echo "KC_QT_CFLAGS=$$cflags" > $@; \
250 echo "KC_QT_LIBS=$$libs" >> $@; \
251 echo "KC_QT_MOC=$$moc" >> $@
Linus Torvalds1da177e2005-04-16 15:20:36 -0700252endif
253
254$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
255
Masahiro Yamada022af622014-08-19 16:34:22 +0900256ifeq ($(MAKECMDGOALS),gconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700257-include $(obj)/.tmp_gtkcheck
258
259# GTK needs some extra effort, too...
260$(obj)/.tmp_gtkcheck:
Adrian Bunk37193142006-01-02 11:25:30 +0100261 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
262 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700263 touch $@; \
264 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200265 echo >&2 "*"; \
266 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
267 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700268 false; \
269 fi \
270 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200271 echo >&2 "*"; \
272 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
273 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
274 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
275 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700276 false; \
277 fi
278endif
279
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400280$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
Linus Torvalds1da177e2005-04-16 15:20:36 -0700281
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400282$(obj)/qconf.o: $(obj)/qconf.moc
Linus Torvalds1da177e2005-04-16 15:20:36 -0700283
Yaakov Selkowitzebca0262012-07-04 18:31:11 -0500284quiet_cmd_moc = MOC $@
285 cmd_moc = $(KC_QT_MOC) -i $< -o $@
286
287$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
288 $(call cmd,moc)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700289
EGRY Gabor46d26312008-01-11 23:46:11 +0100290# Extract gconf menu items for I18N support
291$(obj)/gconf.glade.h: $(obj)/gconf.glade
Peter Foley2d80eb02011-04-26 18:16:53 -0400292 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
Peter Foleya24a1b82011-04-26 18:13:05 -0400293 $(obj)/gconf.glade